unit frmKvalifikace_u;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TfrmKvalifikace = class(TForm)
    btnKonec: TButton;
    lblNadpis: TLabel;
    pnlPodklad: TPanel;
    rdgPracovnici: TRadioGroup;
    grbStroje: TGroupBox;
    chbSoustruh: TCheckBox;
    chbHorizontka: TCheckBox;
    chbVrtacka: TCheckBox;
    chbHoblovka: TCheckBox;
    chbBruska: TCheckBox;
    chbLaser1: TCheckBox;
    chbLaser2: TCheckBox;
    chbTrumatic: TCheckBox;
    chbV_Nuzky: TCheckBox;
    chbM_Nuzky: TCheckBox;
    btnPotvrdit: TButton;
    btnVratit: TButton;
    btnUlozit: TButton;
    btnPrehled: TButton;
    svdUlozitSoubor: TSaveDialog;
    procedure btnKonecClick(Sender: TObject);
    procedure rdgPracovniciClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btnPotvrditClick(Sender: TObject);
    procedure btnVratitClick(Sender: TObject);
    procedure btnUlozitClick(Sender: TObject);
    procedure btnPrehledClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmKvalifikace: TfrmKvalifikace;

implementation

{$R *.dfm}
type
  Kompetence = ARRAY[0..20,0..20] of tCheckBoxState;
var
  CanWork : Kompetence;
  f       : file of kompetence;

procedure TfrmKvalifikace.btnKonecClick(Sender: TObject);
begin
  close;
end;

procedure TfrmKvalifikace.btnPotvrditClick(Sender: TObject);
var
  i,j,maxstroj:integer;
begin
  i := rdgPracovnici.ItemIndex;    //index pracovnika
  maxstroj := grbStroje.ControlCount;   //pocet stroju
  for j := 0 to maxstroj - 1 do
    Canwork[i,j] := (grbStroje.controls[j] as TCheckbox).State;

  frmKvalifikace.btnPotvrdit.Enabled  := false;
  frmKvalifikace.btnVratit.Enabled    := false;
  frmKvalifikace.btnUlozit.Enabled    := true;
  frmKvalifikace.grbStroje.Enabled    := false;

end;

procedure TfrmKvalifikace.btnPrehledClick(Sender: TObject);
var
  i,j,maxprac,maxstroj:integer;
  AppPath : string;
  VystSoubor  : string;
  t : textfile;
begin
  maxprac  := rdgPracovnici.ControlCount;
  maxstroj := grbStroje.ControlCount;
  GetDir(0,AppPath);

  frmKvalifikace.svdUlozitSoubor.InitialDir := AppPath;

  if svdUlozitSoubor.Execute then
    VystSoubor := svdUlozitSoubor.FileName
  else
    exit;

  AssignFile(t, VystSoubor);
  rewrite(t);

  write(t,'':20);
  for I := 0 to maxstroj - 1 do
    write(t, copy((grbStroje.controls[i] as TCheckbox).name,4,6), ' ');

  closefile(t);
end;

procedure TfrmKvalifikace.btnUlozitClick(Sender: TObject);
begin
  rewrite(f);
  write(f,CanWork);
  closefile(f);
  frmKvalifikace.btnPotvrdit.Enabled  := false;
  frmKvalifikace.btnVratit.Enabled    := false;
  frmKvalifikace.btnUlozit.Enabled    := false;
  frmKvalifikace.grbStroje.Enabled    := false;

end;

procedure TfrmKvalifikace.btnVratitClick(Sender: TObject);
var
  i,j,maxstroj:integer;
begin
  frmKvalifikace.btnPotvrdit.Enabled  := true;
  frmKvalifikace.btnVratit.Enabled    := true;
  frmKvalifikace.btnUlozit.Enabled    := false;
  frmKvalifikace.grbStroje.Enabled    := true;
  i := rdgPracovnici.ItemIndex;
  maxstroj := grbStroje.ControlCount;
  for j := 0 to maxstroj - 1 do
    (grbStroje.controls[j] as TCheckbox).State := Canwork[i,j];
end;

procedure TfrmKvalifikace.FormActivate(Sender: TObject);
var
  i,j,maxprac,maxstroj:integer;
begin
  AssignFile(f,'kvalifikace.bin');
{$I-}
  Reset(f);
{$I+}
  if ioresult = 0 then begin
     read(f,CanWork);
     CloseFile(f);
  end else begin
     ShowMessage('Soubor s kompetencemim neexistuje');
     maxprac  := rdgPracovnici.ControlCount;
     maxstroj := grbStroje.ControlCount;
     for i := 0 to maxprac - 1 do
       for j := 0 to maxstroj - 1 do
         CanWork[i,j] := cbUnChecked;
  end;
end;

procedure TfrmKvalifikace.rdgPracovniciClick(Sender: TObject);
var
  i,j,maxstroj:integer;
begin
  frmKvalifikace.btnPotvrdit.Enabled  := true;
  frmKvalifikace.btnVratit.Enabled    := true;
  frmKvalifikace.btnUlozit.Enabled    := false;
  frmKvalifikace.grbStroje.Enabled    := true;
  i := rdgPracovnici.ItemIndex;
  maxstroj := grbStroje.ControlCount;
  for j := 0 to maxstroj - 1 do
    (grbStroje.controls[j] as TCheckbox).State := Canwork[i,j];
end;

end.
